# Quadcopter

The quad/ directory contains all code that programs the quadcopter. This
includes any C libraries we have written, any HDL to program the Zybo on
the quad, and the XSDK main project that runs on the Zybo.

The main quad application is written as a library, and located at:
```
src/quad_app/   ("main" function in quad_app.c)
```

The main XSDK project that actually runs on the Zybo is located at:
```
xsdk_workspace/real_quad/
```

We also have a complemetary "virtual quad" to ease testing:
```
src/virt_quad/
```

## Building

To build the libraries:
```
make
```

You can also build each library individually inside their respective project
directories:
```
cd src/<project> && make
```

## Testing

_Write tests! It makes automating things so much easier._

Run the unit and functional tests:
```
make test
```

You can also run the test for a specific library inside its respective project
directory:
```
cd src/<project> && make test
```

### Manually the hardware interface

Of course, we cannot run our automated tests on code that needs the Zybo. But
we have still written manual tests that you can use to test each specific
driver in the hardware interface.

Look in `xsdk_workspace/real_quad/src/hw_impl_zybo_tests.c` for instructions.
